pipeline {
    agent {
        node {
            label 'master'
        }
    }


    stages {
        stage('Merge ') {
           steps {
              checkout scm
            }
        }


//terraform,vault & chef inspec setup//
        stage('Tools Set-up') {
           steps {
              sh """
                  wget https://releases.hashicorp.com/terraform/0.11.3/terraform_0.11.3_linux_amd64.zip
                  sudo apt-get install -y zip unzip
                  unzip terraform_0.11.3_linux_amd64.zip
                  sudo mv terraform /usr/local/bin
                  rm -rf terraform_0.11.3_linux_amd64.zip
                  """
		          }
		  } 



//terraform initiated, valdated and planned//
        stage('Terraform Init/validate/plan for Test') {
           steps {
           timeout(time: 10, unit: 'MINUTES'){
            script {
                    env.directory = input message: 'Deploy for Test Environment', ok: 'Deploy'
                }
           dir('Test'){
                sh  """
                    ${TERRAFORM_CMD} init -backend=true -input=false
     	            ${TERRAFORM_CMD} validate
                    ${TERRAFORM_CMD} plan -out=tfplan -input=false 
                    """
                   }
	            }
	        }
	    }

        
        

//Aprroval Gate for the terraform Apply//
        stage('Approval for Test') {
	       steps {
	       dir('Test'){
                       timeout(time: 10, unit: 'MINUTES') {
                       input id: 'Approval gate', message: 'Deploy TEST_sample?', ok: 'Deploy', submitter: 'vikas'
		          }
		      }
	       }
	    }
	    

//terraform template accept the git merge request commit into git //
	      stage('Accept merge Request'){
             steps {
             script{
                sh """  
                    curl --header "PRIVATE-TOKEN: QHr4DvVmPNVaLpyHnKyk" https://gitlab.com/api/v4/projects/5305117/merge_requests?state=opened > /tmp/MR
                    awk -F "," '{print \$2}' /tmp/MR | awk -F ":" '{print \$2}' > /tmp/iid
                    IID=`cat /tmp/iid`
                    curl --header "PRIVATE-TOKEN: QHr4DvVmPNVaLpyHnKyk" https://gitlab.com/api/v4/projects/5305117/merge_requests/\$IID/approve
                   """
                   }
           }

}

		 
 // be sanity check,end points like s3 or ec2, Dynamo-DB which is mentioned in the terraform template //
        stage("Run unit tests"){
      steps {
        script {
          try {
            sh  """  chmod 755 sanity2.sh && ./sanity2.sh """
        }
        catch (exc) {
            echo 'Something failed!'
            retry(3){
            input "retry?"
            sh './sanity2.sh'
            }
        }
        }
        }
        }
    
     
    

//terraform apply 	//   
	  stage('Terraform-Apply for Test'){
	     steps {
	       dir('Test'){
	             sh  """
                ${TERRAFORM_CMD} apply -lock=false  tfplan
                    """
             	} 
        	}
        } 
        
        
        
        //terraform initiated, valdated and planned//
        stage('Terraform Init/validate/plan for qa') {
           steps {
           timeout(time: 10, unit: 'MINUTES'){
            script {
                    env.directory = input message: 'Deploy for Test Environment', ok: 'Deploy'
                }
           dir('qa'){
                sh  """
                    ${TERRAFORM_CMD} init -backend=true -input=false
     	            ${TERRAFORM_CMD} validate
                    ${TERRAFORM_CMD} plan -out=tfplan -input=false 
                    """
                   }
	            }
	        }
	    }

        
        


	    
//terraform apply 	//   
	  stage('Aprroval to Deploy-qa'){
	     steps {
	       dir('qa'){
	                   timeout(time: 10, unit: 'MINUTES') {
                       input id: 'Approval gate', message: 'Deploy TEST_sample?', ok: 'Deploy', submitter: 'vikas'
	             sh  """
                ${TERRAFORM_CMD} apply -lock=false  tfplan
                    """
             	} 
        	}
        }
        }
	    
	        //terraform initiated, valdated and planned//
        stage('Terraform Init/validate/plan for uat') {
           steps {
           timeout(time: 10, unit: 'MINUTES'){
            script {
                    env.directory = input message: 'Deploy for Test Environment', ok: 'Deploy'
                }
           dir('uat'){
                sh  """
                    ${TERRAFORM_CMD} init -backend=true -input=false
     	            ${TERRAFORM_CMD} validate
                    ${TERRAFORM_CMD} plan -out=tfplan -input=false 
                    """
                   }
	            }
	        }
	    }

        
        


	    
//terraform apply 	//   
	  stage('Approval to Deploy-UAT'){
	     steps {
	       dir('uat'){
	                   timeout(time: 10, unit: 'MINUTES') {
                       input id: 'Approval gate', message: 'Deploy TEST_sample?', ok: 'Deploy', submitter: 'vikas'
	             sh  """
                ${TERRAFORM_CMD} apply -lock=false  tfplan
                    """
             	} 
        	}
        } 	    
	    }
	        //terraform initiated, valdated and planned//
        stage('Terraform Init/validate/plan for prod') {
           steps {
           timeout(time: 10, unit: 'MINUTES'){
            script {
                    env.directory = input message: 'Deploy for Test Environment', ok: 'Deploy'
                }
           dir('prod'){
                sh  """
                    ${TERRAFORM_CMD} init -backend=true -input=false
     	            ${TERRAFORM_CMD} validate
                    ${TERRAFORM_CMD} plan -out=tfplan -input=false 
                    """
                   }
	            }
	        }
	    }

        
        


	    
//terraform apply 	//   
	  stage('Approval to Deploy-Prod'){
	     steps {
	       dir('prod'){
	                   timeout(time: 10, unit: 'MINUTES') {
                       input id: 'Approval gate', message: 'Deploy TEST_sample?', ok: 'Deploy', submitter: 'vikas'
	             sh  """
                ${TERRAFORM_CMD} apply -lock=false  tfplan
                    """
             	} 
        	}
        }
        }
        
//to run the inspect test//

	   stage('Smoke-Test') {
	      steps {
	        sh """
	        echo "Chef inspec completed"
	            """
	          } 
	     }    
      }
  
  }

